#include <iostream>
#include <cstdlib>
#include <boost/type_traits.hpp>
#include <boost/utility/enable_if.hpp>
using namespace std;
using namespace boost;

template<typename T>
  void copy_n( const T* from, int n, T* to,
               typename enable_if< is_pod<T> >::type* =0 )
  {
      memcpy( to, from, sizeof(T)*n );
  }

template<typename T>
  void copy_n( const T* from, int n, T* to,
               typename disable_if< is_pod<T> >::type* =0 )
  {
      for(int i=0; i!=n; ++i)
          *to++ = *from++;
  }

struct NonPod
{
    NonPod(){ cout << "constructor" << endl; }
    ~NonPod(){ cout << "destructor" << endl; }
    void operator=(const NonPod&){ cout << "copy" << endl; }
};

int main()
{
    char   x[10];
    NonPod y[10];
    copy_n( x, 10, x ); // memcpyłĂ΂
    copy_n( y, 10, y ); // for[vłĂ΂
    return 0;
}
