#include <iostream>
#include <boost/graph/graph_traits.hpp>
#include <boost/graph/adjacency_list.hpp>
#include <boost/graph/dijkstra_shortest_paths.hpp>
#include <boost/graph/visitors.hpp>
#include <boost/graph/graph_utility.hpp>
using namespace boost;

typedef adjacency_list< vecS, vecS, directedS,
    no_property,
    property<edge_weight_t, int>
> Graph;
typedef graph_traits<Graph>::vertex_descriptor Vertex;
typedef std::pair<int,int>                     Edge;

int main()
{
    // ӂ̃Xg
    // "_0_1ւ̕", "_0_2ւ̕"
    // Ȃǂ݂邱Ƃ
    Edge links[] = {
        Edge(0,1), Edge(0,2),
        Edge(1,2), Edge(1,4),
        Edge(2,0), Edge(2,3),
        Edge(3,4),
    };
    // eӂ̏d݁i͑SƂ܂j
    int weights[] = {
        1, 1,
        1, 1,
        1, 1,
        1,
    };

    // _0`_4̂T_ȂOt\z
    const size_t nEdges = sizeof(links)/sizeof(*links);
    Graph g( links, links+nEdges, weights, 5 );

    Vertex p[5] = {0};

    // n__0ɂdijkstrãASYsB
    // # _0_iɍŒZoHōsɂ́A_ȋOɓ_p[i]
    // # ɍsĂiɐi߂΂悢AƂ񂪓B
    Vertex s = 0;
    dijkstra_shortest_paths( g, s,
        visitor( make_dijkstra_visitor (
        record_predecessors( p, on_edge_relaxed() )
    )));

    // ʂ̕\
    adjacency_list<> tree(5);
    graph_traits<Graph>::vertex_iterator vi, vend;
    for( tie(vi,vend) = vertices(g); vi!=vend; ++vi )
        if( *vi != p[*vi] )
            add_edge( p[*vi], *vi, tree );

    print_graph( tree );
    return 0;
}
