#include <iostream>
#include <typeinfo>
#include <boost/mpl/list.hpp>
#include <boost/mpl/push_front.hpp>
#include <boost/mpl/reverse.hpp>
#include <boost/mpl/replace.hpp>
#include <boost/mpl/for_each.hpp>
using namespace boost::mpl;

typedef list<bool, short, int, long>         Ints;
typedef push_front<Ints, unsigned int>::type Ints2;
typedef reverse<Ints2>::type                 Ints3;
typedef replace<Ints3,int,char>::type        Ints4;

struct {
  template<typename T>
    void operator()( const T& ) const
      { std::cout << typeid(T).name() << std::endl; }
} print_type;

int main()
{
    for_each<Ints4>( print_type );
    return 0;
}
